#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "bignum.h"

#define BINSHORT 16			/* Number of bits in unsigned short. */
int
bnum_shl(struct bignum *bn, unsigned int shift)
{
	assert(bn != 0);
	
	unsigned int buff, mask;
	int i, shl, shr;
	int *pval;

	if (shift == 0)
		return 0;
	
	shr = 32 - (shift % BINSHORT);
	mask = 0;
	shl = shift % BINSHORT;

	if (shl != 0) {
		for (i = 1; i <= bn->len/2; i++) {
			pval = ((int*)(bn->val + 2*i - 2));
			buff = (*pval);
			buff = buff >>shr; 
			*pval = (*pval) << shl;
			*pval = (*pval) | mask;
			mask = buff;
		}
		if (bn->len % 2 != 0)
			bn->val[bn->len - 1] =(bn->val[bn->len - 1]<<shl) | mask;
	}

	shl = shift / BINSHORT;
	if (shl > 0)
		for (i = bn->len - 1; i >= 0; i--) {
			if ((i - shl) < 0)
				bn->val[i] = 0x0000;
			else
				bn->val[i] = bn->val[i - shl];
		}

	bn->top = bn->len - 1;
	while (bn->val[bn->top] == 0) {
		if ( bn->top >= 0)
			--bn->top;
		else
			break;
	}
	return 0;
}
